--- res/res_odbc.c.orig	2010-05-05 03:03:59.000000000 -0400
+++ res/res_odbc.c	2010-05-05 03:05:12.000000000 -0400
@@ -689,9 +689,13 @@
 		while ((obj = ao2_iterator_next(&aoi))) {
 			if (! obj->used) {
 				ast_mutex_lock(&obj->lock);
-				obj->used = 1;
+				/* this time check inside lock to avoid thread problems */
+				if (!obj->used) {
+					obj->used = 1;
+					ast_mutex_unlock(&obj->lock);
+					break;
+				}
 				ast_mutex_unlock(&obj->lock);
-				break;
 			}
 			ao2_ref(obj, -1);
 		}
